/********************************** pars67.c ********************************/

#include <stdio.h>
#include "cgmparse.h"
#include "chkcgm.h"

char *blen = "<<* Too Few Bytes *>>";

char *Class6[] = { "<<* Bad ID *>>",                   
                   "Escape"
                 };

char *Class7[] = { "<<* Bad ID *>>",                   
                   "Message",
                   "Application Data"
                 };



int read_hex(void)
{ /* displays character strings in hexidecemal */
  /* returns the number of characters */
  /* limited to 254 characters */
  unsigned char nchar;
  int j,k;
  fread( &nchar, 1, 1, cgmsrc);   /* read one char value */
  if (nchar > 254)
  {
     fprintf(out," Length > 254");
     nchar = 254;
  }

  fread( &cgm_cbuffer, 1, nchar, cgmsrc);   /* read nchar chars */
  cgm_cbuffer[nchar] = '\0';
  cgm_header.length -= (nchar +1);
  for ( j = 0;j < nchar;)
  {
     fprintf(out,"\n  ");
     for ( k = 1;(k <= 32) && (j < nchar); k++,j++)
     {
           fprintf(out,"%02X ",cgm_cbuffer[j]);
     }

  }
  return(nchar);

}


void cgm_pars67(void)
{
   int p1;

   if (cgm_header.class == 6)
   {
        if ( (cgm_header.id <= MAXCLASS6ID) && (cgm_header.id > 0) )
        {
            fprintf(out,"\n%s",Class6[cgm_header.id]);
            if (!get_look_up(cgm_header.class,cgm_header.id) && mfList)
               fprintf(out," <<* Not in Metafile Elements List *>>");

        }
        else
            fprintf(out,"\n Class 6 , ID Error (%d)",cgm_header.id);

        if (cgm_header.id == 1)
        {   /* Escape */
            if( cgm_header.length < 3)
            {
               fprintf(out," %s",blen);
               return;
            }
            p1 = cgm_oneival(); /* escape id */
            fprintf(out," %d ",p1);
            if (hex == 0)
            {
               cgm_read_string();
               fprintf(out," \"%s\"",cgm_cbuffer);
            }
            else
               read_hex();
        }
   }
   else
   {
        if ( (cgm_header.id <= MAXCLASS7ID) && (cgm_header.id > 0) )
        {
            fprintf(out,"\n%s",Class7[cgm_header.id]);
            if (!get_look_up(cgm_header.class,cgm_header.id) && mfList)
                fprintf(out," <<* Not in Metafile Elements List *>>");
        }
        else
            fprintf(out,"\n Class 7 , ID Error (%d)",cgm_header.id);
        if ( cgm_header.id == 1)
        { /* Message */
            if( cgm_header.length < 3)
            {
                fprintf(out," %s",blen);
                return;
            }
            p1 = cgm_oneival();  /* action flag */
            if ( p1 == 0)
               fprintf(out," No Action Req ");
            else if ( p1 == 1)
               fprintf(out," Action Req ");
            else
               fprintf(out," <<* Bad Value *>> (%d) ",p1);
            cgm_read_string();
            fprintf(out," \"%s\"",cgm_cbuffer);
        }
        else
        { /* Application Data */
           if( cgm_header.length < 3)
           {
               fprintf(out," %s",blen);
               return;
           }
           p1 = cgm_oneival(); /* app data id */
           fprintf(out," %d ",p1);
           if (hex == 0)
           {
              cgm_read_string();
              fprintf(out," \"%s\"",cgm_cbuffer);
           }
           else
              read_hex();
        }

   }



}














