/********************************* parsasm.c ********************************/

#include <stdio.h>
#include "cgmparse.h"


long cgm_onerval(void)
{ /* reads and returns one fixed point value */
  /* cgm_header.lenght is decreamented 4 bytes */
  /* does not check if length >= 4 bytes */
   int d1,d2;
   cgm_header.length -= 4;
   fread( &d1, 2, 1, cgmsrc); 
   fread( &d2, 2, 1, cgmsrc); 
   asm mov ax,d1;
   asm xchg al,ah;
   asm mov dx,ax;
   asm mov ax,d2;
   asm xchg al,ah;
}

int cgm_oneival(void)
{ /* reads and returns one integer value */
  /* cgm_header.length is decreamented 2 bytes */
  /* does not check if length >= 2 bytes */
  
   int dummy;
   cgm_header.length -= 2;
   fread( &dummy, 2, 1, cgmsrc); 
   asm mov ax,dummy;
   asm xchg al,ah;
}

int _cgm_oneival(void)
{ /* same as cgm_oneival() except cgm_header.length is not updated */

   int dummy;
   fread( &dummy, 2, 1, cgmsrc); 
   asm mov ax,dummy;
   asm xchg al,ah;
}
